local cql = ClassicQuestLog

cql.MinimapButton = ClassicQuestLogMinimapButton

function cql.MinimapButton:Setup()
    self:SetFrameLevel(Minimap:GetFrameLevel()+10)
    self:Update()
end

function cql.MinimapButton:Update()
    local angle = cql.settings.MinimapPosition or 116
    self:SetPoint("CENTER",Minimap,"CENTER",(105*cos(angle)),(105*sin(angle)))
    local isShown = cql.MinimapButton:IsShown()
    if isShown and not cql.settings.ShowMinimapButton then
        self:Hide()
    elseif not isShown and cql.settings.ShowMinimapButton then
        self:Show()
    end
end

function cql.MinimapButton:OnEnter()
    GameTooltip:SetOwner(self,"ANCHOR_LEFT")
    GameTooltip:AddLine("\124cffffffffClassic Quest Log")
    GameTooltip:AddLine("Version "..GetAddOnMetadata("Classic Quest Log","Version"))
    GameTooltip:Show()
end

function cql.MinimapButton:OnLeave()
    GameTooltip:Hide()
end

function cql.MinimapButton:OnMouseDown()
    --self.Icon:SetPoint("CENTER",0,-2)
    self.Icon:SetSize(21,21)
    self.Icon:SetVertexColor(0.65,0.65,0.65)
end

function cql.MinimapButton:OnMouseUp()
    self.Icon:SetSize(23,23)
    --self.Icon:SetPoint("CENTER",1,0)
    self.Icon:SetVertexColor(1,1,1)
end

function cql.MinimapButton:OnClick()
    ClassicQuestLog:Toggle()
end

function cql.MinimapButton:OnDragStart()
    self:SetScript("OnUpdate",self.OnDragUpdate)
end

function cql.MinimapButton:OnDragStop()
    self:OnMouseUp()
    self:SetScript("OnUpdate",nil)
end

function cql.MinimapButton:OnDragUpdate(elapsed)
	local x,y = GetCursorPosition()
	local scale = Minimap:GetEffectiveScale()
    local minX,minY = Minimap:GetCenter()
    cql.settings.MinimapPosition = math.deg(math.atan2(y/scale-minY,x/scale-minX))
    self:Update()
end
